org.modeshape.jmx

## Interface RepositoryStatisticsMXBean

- All Known Implementing Classes:
    RepositoryStatisticsBean

      @MXBean
      @Details(value="JMX MXBean which exposes various repository metrics")
      public interface RepositoryStatisticsMXBean

  JXM MXBean interface which exposes various monitoring information for a running repository. The information exposed by this interface is obtained via the active `RepositoryMonitor` instance.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<EnumDescription>` | `getDurationMetrics()` Get the `DurationMetric` enumerations that are available for use by the caller with `getDurations(org.modeshape.jcr.api.monitor.DurationMetric, org.modeshape.jcr.api.monitor.Window)`.
    `HistoricalData` | `getDurations(DurationMetric metric, Window windowInTime)` Get the statics for the specified duration metric during the given window in time.
    `List<DurationData>` | `getLongestRunning(DurationMetric metric)` Get the longest-running activities recorded for the specified metric.
    `List<EnumDescription>` | `getTimeWindows()` Get the `Window` enumerations that are available for use by the caller with `getValues(org.modeshape.jcr.api.monitor.ValueMetric, org.modeshape.jcr.api.monitor.Window)` and `getDurations(org.modeshape.jcr.api.monitor.DurationMetric, org.modeshape.jcr.api.monitor.Window)`.
    `List<EnumDescription>` | `getValueMetrics()` Get the `ValueMetric` enumerations that are available for use by the caller with `getValues(org.modeshape.jcr.api.monitor.ValueMetric, org.modeshape.jcr.api.monitor.Window)`.
    `HistoricalData` | `getValues(ValueMetric metric, Window windowInTime)` Get the statistics for the specified value metric during the given window in time.

- - ### Method Detail

    - #### getValueMetrics

          @Details(value="A list of enums which represent the available value metrics that should be used as parameters for the getValues operation")
          List<EnumDescription> getValueMetrics()

      Get the `ValueMetric` enumerations that are available for use by the caller with `getValues(org.modeshape.jcr.api.monitor.ValueMetric, org.modeshape.jcr.api.monitor.Window)`.
      Returns:
        a [name, description] map of available value metrics; never null
      See Also:
        `RepositoryMonitor.getAvailableValueMetrics()`

    - #### getDurationMetrics

          @Details(value="A list of enums which represent the available duration metrics that should be used as parameters for the getDurations and getLongestRunning operations")
          List<EnumDescription> getDurationMetrics()

      Get the `DurationMetric` enumerations that are available for use by the caller with `getDurations(org.modeshape.jcr.api.monitor.DurationMetric, org.modeshape.jcr.api.monitor.Window)`.
      Returns:
        a [name, description] map of available duration metrics; never null
      See Also:
        `RepositoryMonitor.getAvailableDurationMetrics()`

    - #### getTimeWindows

          @Details(value="A list of enums which represent the available time intervals that should be used as operation parameters")
          List<EnumDescription> getTimeWindows()

      Get the `Window` enumerations that are available for use by the caller with `getValues(org.modeshape.jcr.api.monitor.ValueMetric, org.modeshape.jcr.api.monitor.Window)` and `getDurations(org.modeshape.jcr.api.monitor.DurationMetric, org.modeshape.jcr.api.monitor.Window)`.
      Returns:
        a [name, description] map of available time windows; never null
      See Also:
        `RepositoryMonitor.getAvailableWindows()`

    - #### getValues

          @Details(value="Returns the values of a certain type in a given period of time")
          HistoricalData getValues(@Details(value="The value metric enum name (see the ValueMetrics)")
                                              ValueMetric metric,
                                              @Details(value="The time window enum name  (see the TimeWindows)")
                                              Window windowInTime)
                                   throws MBeanException

      Get the statistics for the specified value metric during the given window in time.
      Parameters:
        `metric` - the value metric; may not be null
        `windowInTime` - the window specifying which statistics are to be returned; may not be null
      Returns:
        the statistical data; never null
      Throws:
        `MBeanException` - if anything unexpected fails while performing the operation.
      See Also:
        `RepositoryMonitor.getHistory(org.modeshape.jcr.api.monitor.ValueMetric, org.modeshape.jcr.api.monitor.Window)`

    - #### getDurations

          @Details(value="Returns the values for a duration type in a period of time")
          HistoricalData getDurations(@Details(value="The duration metric enum name (see the DurationMetrics)")
                                                 DurationMetric metric,
                                                 @Details(value="The time window enum name (see the TimeWindows)")
                                                 Window windowInTime)
                                      throws MBeanException

      Get the statics for the specified duration metric during the given window in time.
      Parameters:
        `metric` - the duration metric; may not be null
        `windowInTime` - the window specifying which statistics are to be returned; may not be null
      Returns:
        the statistical data; never null
      Throws:
        `MBeanException` - if anything unexpected fails while performing the operation.
      See Also:
        `RepositoryMonitor.getHistory(org.modeshape.jcr.api.monitor.DurationMetric, org.modeshape.jcr.api.monitor.Window)`

    - #### getLongestRunning

          @Details(value="Returns the longest running time of a duration type (e.g. longest running session)")
          List<DurationData> getLongestRunning(@Details(value="The duration metric enum name  (see the DurationMetrics)")
                                                          DurationMetric metric)
                                               throws MBeanException

      Get the longest-running activities recorded for the specified metric. The results contain the duration records in order of increasing duration, with the activity with the longest duration appearing last in the list.
      Parameters:
        `metric` - the duration metric; may not be null
      Returns:
        the longest duration data; never null but possibly empty if no such activities were performed
      Throws:
        `MBeanException` - if anything unexpected fails while performing the operation.
      See Also:
        `RepositoryMonitor.getLongestRunning(org.modeshape.jcr.api.monitor.DurationMetric)`

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.